/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


void
on_window_degustation_destroy          (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_object_destroy (GTK_OBJECT (window_degustation_form));

	gtk_widget_set_sensitive(window_detail, TRUE);

}


void
on_window_degustation_check_resize     (GtkContainer    *container,
                                        gpointer         user_data)
{

}


void
on_button_degustation_form_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

#if (defined DEBUG_LEVEL_1)
	printf("on_on_button_degustation_form_clicked:B:\n");
#endif

	/* 
	 * desactive window_xcave
	 */
	gtk_widget_set_sensitive(window_detail, FALSE);

	window_degustation_form = create_window_degustation();

	/* 
	 * various fields initialisation 
	 */
	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_domain_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinnom"))));

	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_app_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinapentry"))));
	
	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_reg_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinregentry"))));

	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_vintage_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinan"))));

	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_color_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vincoulentry"))));

	gtk_entry_set_text (
              GTK_ENTRY (lookup_widget (window_degustation_form, "xcave_degustation_productor_entry")),
              gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinprod"))));

	
	gtk_widget_show (window_degustation_form);

#if (defined DEBUG_LEVEL_1)
	printf("on_on_button_degustation_form_clicked:E:\n");
#endif
}

void
on_xcave_degustation_button_ok_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy (GTK_OBJECT (window_degustation_form));

	gtk_widget_set_sensitive(window_detail, TRUE);

}


void
on_xcave_degustation_button_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_object_destroy (GTK_OBJECT (window_degustation_form));

	gtk_widget_set_sensitive(window_detail, TRUE);

}
