 /*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

#define DEBUG_LEVEL_1 1

void
xcave_create_TreeList_drinking(void)
{
	GtkListStore		*StoreList_drinking;
	GtkWidget			*scrolledwindow_drinking;
	GtkWidget			*TreeList_drinking;
	GtkTreeViewColumn   *col;
	GtkCellRenderer     *renderer;
#if (defined DEBUG_LEVEL_1)
	printf("xcave_create_TreeList_drinking:B:\n");
#endif

	scrolledwindow_drinking = lookup_widget(window_detail,"scrolledwindow_drinking");

	/* Creates a new tree store as with n_columns columns each of the types passed in. */
	StoreList_drinking = gtk_list_store_new(NUM_COLS_TREELIST_DRINKING, 
											G_TYPE_UINT, 
											G_TYPE_UINT, 
											G_TYPE_STRING, 
											G_TYPE_STRING);

	/* create view TreeList_drinking */
	TreeList_drinking = gtk_tree_view_new_with_model (GTK_TREE_MODEL(StoreList_drinking));
	gtk_widget_show (TreeList_drinking);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_drinking), TreeList_drinking);
	/* --- TreeList Column #1 --- */
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes(_("Dinking years"),
													renderer,
													"text", 
													COL_TREELIST_DRINKING_DATE,
													NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(TreeList_drinking), col);
	/* --- TreeList Column #2 -- QUANTITY --- */
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes(_("Quantity"),
												   renderer,
												   "text", 
												   COL_TREELIST_DRINKING_QTY,
												   NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(TreeList_drinking), col);
	/* --- TreeList Column #3 -- PRICE --- */
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes(_("Rated"),
												   renderer,
												   "text", 
												   COL_TREELIST_NOTE,
												   NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(TreeList_drinking), col);
	/* --- TreeList Column #4 -- SUPPLIER --- */
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes(_("Comment"),
												   renderer,
												   "text", 
												   COL_TREELIST_COMMENTAIRE,
												   NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(TreeList_drinking), col);
g_signal_connect(G_OBJECT(TreeList_drinking), "row-activated", G_CALLBACK(on_TreeList_Drinking_double_click), NULL);
	GLADE_HOOKUP_OBJECT (window_detail, TreeList_drinking, "treelist_drinking");

#if (defined DEBUG_LEVEL_1)
	printf("xcave_create_TreeList_drinking:E:\n");
#endif
	return;
}



void
on_DrinkingOk_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

	GtkWidget		*TreeList_drinking;
	GtkListStore	*StoreList_drinking_model;
	GtkTreeIter 	pIter;
	Drinking		*tmpDrinking;
	char           statxt[80];
	GtkStatusbar  *statv;

#if (defined DEBUG_LEVEL_1)
	printf("on_DrinkingOk_clicked:B:\n");
#endif

	tmpDrinking = malloc (sizeof(Drinking));
	memset(tmpDrinking,'\0',sizeof(Drinking));

	tmpDrinking->Conso = atoi(
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_year"))));
	tmpDrinking->qty = atoi(
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "spinbutton_drinking_qty"))));
	strcpy(tmpDrinking->Note,
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_rated"))));
	strcpy(tmpDrinking->Commentaire,
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_comment"))));

	TreeList_drinking = lookup_widget(window_detail,"treelist_drinking");
	StoreList_drinking_model	= (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)TreeList_drinking);
	gtk_list_store_append(StoreList_drinking_model, &pIter);/* C */
	gtk_list_store_set(StoreList_drinking_model, &pIter,/* C */ 
						COL_TREELIST_DRINKING_DATE, (guint)tmpDrinking->Conso,
						COL_TREELIST_DRINKING_QTY, (guint)tmpDrinking->qty,
						COL_TREELIST_NOTE, tmpDrinking->Note,
						COL_TREELIST_COMMENTAIRE, tmpDrinking->Commentaire,
						-1);			

	NbBottleDetail -= tmpDrinking->qty;
	
	char          ach[purchaseDate_size];
	sprintf (ach, "%d", nowan);
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(window_detail,"entry_drinking_year")),(gchar *)ach);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_drinking_qty")), (guint) 1);
	gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_rated")),"");
	gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_comment")),"");

	/*
	* update de la statusbar indiquant le nb de bouteille du vin selectionne
	* se trouvant dans le stock
	*/
	statv = (GtkStatusbar *) lookup_widget (window_detail, "StatusbarDetail");
	sprintf (statxt, _("Number of bottles for the selection : %d"), NbBottleDetail);
	if (statid_detail != 0) gtk_statusbar_remove (statv, ctxtid_detail, statid_detail);
	statid_detail = gtk_statusbar_push (statv, ctxtid_detail, statxt);

	g_free(tmpDrinking);
#if (defined DEBUG_LEVEL_1)
	printf("on_DrinkingOk_clicked:E:\n");
#endif

}

gboolean
on_TreeList_Drinking_double_click (GtkWidget       *widget,
                                   GdkEventButton  *event,
                                   gpointer         user_data)
{
	gchar	*tmpNote;
	gchar	*tmpComment;	
	GtkWidget	*TreeList_drinking;
	GtkListStore	*StoreList_drinking_model;
	GtkTreeIter 	pIter;
	Drinking	*tmpDrinking;
	GtkTreeSelection *selection;
	
#if (defined DEBUG_LEVEL_1)
	printf("on_TreeList_drinking_double_click:B:\n");
#endif
	tmpDrinking = malloc (sizeof(Drinking));

	memset(tmpDrinking,'\0',sizeof(Drinking));
	TreeList_drinking = lookup_widget(window_detail,"treelist_drinking");
	StoreList_drinking_model = (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)TreeList_drinking);
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(TreeList_drinking));

	gtk_tree_selection_get_selected(selection, (GtkTreeModel **)&StoreList_drinking_model, (GtkTreeIter *)&pIter);
	gtk_tree_model_get ((GtkTreeModel *)StoreList_drinking_model, &pIter,
											COL_TREELIST_DRINKING_DATE, &tmpDrinking->Conso,
											COL_TREELIST_DRINKING_QTY, &tmpDrinking->qty,
											COL_TREELIST_NOTE, &tmpNote,
											COL_TREELIST_COMMENTAIRE, &tmpComment,
											-1);

	char          ach[purchaseDate_size];
	sprintf (ach, "%d", tmpDrinking->Conso);
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(window_detail,"entry_drinking_year")),(gchar *)ach);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_drinking_qty")), (guint)tmpDrinking->qty);
	gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_rated")),tmpNote);
	gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_comment")),tmpComment);

	g_free(tmpDrinking);
	g_free(tmpNote);
	g_free(tmpComment);
#if (defined DEBUG_LEVEL_1)
	printf("on_TreeList_drinking_double_click:E:\n");
#endif

  return FALSE;

}


void
on_DrinkingDelete_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*TreeList_drinking;
	GtkListStore	*StoreList_drinking_model;
	GtkTreeIter 	pIter;
	GtkTreeSelection *selection;
	gint tmpQty;
	char		statxt[80];
	GtkStatusbar	*statv;
#if (defined DEBUG_LEVEL_1)
	printf("on_DrinkingDelete_clicked:B:\n");
#endif
	

	TreeList_drinking = lookup_widget(window_detail,"treelist_drinking");
	StoreList_drinking_model = (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)TreeList_drinking);
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(TreeList_drinking));

	if(gtk_tree_selection_get_selected (selection, (GtkTreeModel **) &StoreList_drinking_model, &pIter)){
		// 2.2.9 qty false after removing a drinking wine
		gtk_tree_model_get (StoreList_drinking_model, &pIter, COL_TREELIST_DRINKING_QTY, &tmpQty, -1);
		NbBottleDetail += tmpQty;
		gtk_list_store_remove( StoreList_drinking_model,
													&pIter);
		statv = (GtkStatusbar *) lookup_widget (window_detail, "StatusbarDetail");
		sprintf (statxt, _("Number of bottles for the selection : %d"), NbBottleDetail);
		if (statid_detail != 0) gtk_statusbar_remove (statv, ctxtid_detail, statid_detail);
		statid_detail = gtk_statusbar_push (statv, ctxtid_detail, statxt);
	}
	else {
		 GtkWidget	*dialog;
		 dialog = gtk_message_dialog_new ((GtkWindow *)window_detail,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("You must select a line!!!")
                                  );
 		gtk_dialog_run (GTK_DIALOG (dialog));
 		gtk_widget_destroy (dialog);
	}
#if (defined DEBUG_LEVEL_1)
	printf("on_DrinkingDelete_clicked:E:\n");
#endif

}


void
on_DrinkingModify_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*TreeList_drinking;
	GtkListStore	*StoreList_drinking_model;
	GtkTreeIter 	pIter;
	Drinking	*tmpDrinking;
	GtkTreeSelection *selection;
	char		statxt[80];
	GtkStatusbar	*statv;
	gint tmpQty;

#if (defined DEBUG_LEVEL_1)
	printf("on_PurchaseModify_clicked:B:\n");
#endif
	
	tmpDrinking = malloc (sizeof(Drinking));
	memset(tmpDrinking,'\0',sizeof(Drinking));

	tmpDrinking->Conso = atoi(
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_year"))));
	tmpDrinking->qty = atoi(
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "spinbutton_drinking_qty"))));
	strcpy(tmpDrinking->Note,
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_rated"))));
	strcpy(tmpDrinking->Commentaire,
		gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_comment"))));

	TreeList_drinking = lookup_widget(window_detail,"treelist_drinking");
	StoreList_drinking_model	= (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)TreeList_drinking);
	
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(TreeList_drinking));
  // on test si une ligne est sélectionnée
	if(gtk_tree_selection_get_selected(selection, (GtkTreeModel **)&StoreList_drinking_model, &pIter)){
		gtk_tree_model_get ((GtkTreeModel *)StoreList_drinking_model, &pIter, COL_TREELIST_DRINKING_QTY, &tmpQty, -1);
		NbBottleDetail += tmpQty;
		gtk_list_store_set(StoreList_drinking_model, &pIter,/* C */ 
							COL_TREELIST_DRINKING_DATE, (guint)tmpDrinking->Conso,
							COL_TREELIST_DRINKING_QTY, (guint)tmpDrinking->qty,
							COL_TREELIST_NOTE, tmpDrinking->Note,
							COL_TREELIST_COMMENTAIRE, tmpDrinking->Commentaire,
							-1);			

		NbBottleDetail -= tmpDrinking->qty;

		
		char          ach[purchaseDate_size];
		sprintf (ach, "%d", nowan);
		gtk_entry_set_text(GTK_ENTRY(lookup_widget(window_detail,"entry_drinking_year")),(gchar *)ach);
		gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_drinking_qty")), (guint) 1);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_rated")),"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_comment")),"");

		/*
		* update de la statusbar indiquant le nb de bouteille du vin selectionne
		* se trouvant dans le stock
		*/
		statv = (GtkStatusbar *) lookup_widget (window_detail, "StatusbarDetail");
		sprintf (statxt, _("Number of bottles for the selection : %d"), NbBottleDetail);
		if (statid_detail != 0) gtk_statusbar_remove (statv, ctxtid_detail, statid_detail);
		statid_detail = gtk_statusbar_push (statv, ctxtid_detail, statxt);
	}
	else {
		 GtkWidget	*dialog;
		 dialog = gtk_message_dialog_new ((GtkWindow *)window_detail,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("You must select a line!!!")
                                  );
 		gtk_dialog_run (GTK_DIALOG (dialog));
 		gtk_widget_destroy (dialog);
	}
	g_free(tmpDrinking);
	
#if (defined DEBUG_LEVEL_1)
	printf("on_PurchaseModify_clicked:E:\n");
#endif
}

